# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc diff_c
##################################################
proc diff_c {generation} {
global lifefeld nmax newworld savefeld
global exec_dir rlist ncolors

# lifefeld enthaelt die Farbe
# savefeld enthaelt die Konzentrationen

# Maximale Konzentration ncolors
# wird mit Mausklick gesetzt

set D	0.01;     # Anteil, der  diffundiert in 1/Schritt


set clist "$nmax $newworld $D"

# Retten der alten Werte

for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist $savefeld($i,$j)
   }
}

set rlist [eval exec $exec_dir/cdiff $clist]

#Berechnen der neuen Werte
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
     set wert [lindex $rlist [expr $i*($nmax+1)+$j]]
     set savefeld($i,$j) $wert
     set col [expr int($wert)]
     if {$col > $ncolors} {set col $ncolors}
     set lifefeld($i,$j) $col
#puts "$wert $col"
 
     }
   }

}

