# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc calclife3
# DIE zentrale Berechnung
##################################################
proc Disease {} {
global lifefeld nmax newworld savefeld numstates


# Retten der alten Werte

for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      set savefeld($i,$j) $lifefeld($i,$j)
   }
}

#Berechnen der neuen Werte
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
   	
# Bestimmung der Nachbarindizes   	
      set k [expr $i-1]
      set l [expr $j-1]
      set m [expr $i+1]
      set n [expr $j+1]

if {$newworld==1} {
# Setzen der Randindizes
      if {$i==0} {set k $nmax}
      if {$i==$nmax} {set m 0}
      if {$j==0} {set l $nmax}
      if {$j==$nmax} {set n 0}
}    

###########################         	
# DIE REGELN DES AUTOMATEN:
###########################

#Es gibt anfällige (0), infektiöse (1) und , kranke (2) und immune (3) Zellen

randomInit [expr int(100000*[random])]

#Anfällige Zellen können mit gewisser WSK infiziert werden, bei 1 und mehr infizierten Nachbarn
if {$savefeld($i,$j)==0} {
	set num [expr [checknachbar $i $j $k $l $m $n 1]*[random]]
		if {$num > 0.9} { 
		   set lifefeld($i,$j) 1
		} else {   
		   set lifefeld($i,$j) 0
     }
}

#Infektiöse Zellen werden mit gewisser WSK krank
 if {$savefeld($i,$j)==1} {
       if {[random] >=0.6} {
				set lifefeld($i,$j) 2
		} else {
				set lifefeld($i,$j) 1
	  }
 }

# Kranke Zellen bleiben krank, werden immun oder anfällig
 if {$savefeld($i,$j)==2} {
	   set rnd [random]
		set lifefeld($i,$j) 0 ; # (Wird anfällig)
		if {$rnd < 0.5} { set lifefeld($i,$j) 2}; # (Bleibt krank)
		if {$rnd < 0.25} { set lifefeld($i,$j) 3}; # (Wird immun)
 }
	
# Immune Zellen werden mit geringer WSK anfällig (Geburten und Sterbeterm)
 if {$savefeld($i,$j)==3} {
	    if {[random] >= 0.95 } {
          set lifefeld($i,$j) 0
	   }  else {
			 set  lifefeld($i,$j) 3
		}
 }


###########################         	
# ENDE DER REGELN 
###########################
      }
   }
}

proc checknachbar {i j k l m n was} { 

global savefeld
set sum 0

if {$savefeld($k,$l)==$was} {incr sum}
if {$savefeld($i,$l)==$was} {incr sum}
if {$savefeld($m,$l)==$was} {incr sum}
if {$savefeld($k,$j)==$was} {incr sum}                   
if {$savefeld($m,$j)==$was} {incr sum}
if {$savefeld($k,$n)==$was} {incr sum} 
if {$savefeld($i,$n)==$was} {incr sum}
if {$savefeld($m,$n)==$was} {incr sum}
return $sum
}
