# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makecolor {} {
global install_dir color colmax colmin coltab ncolors

#if [info exists color] {unset color}
set upside 1
switch $coltab {
             leo {
                set colmax 255
                set colmin 0
                set id [open $install_dir/colors/leo.dat r]
               }
             black&white {
                set colmax 255
                set colmin 0
                set id [open $install_dir/colors/blackwhite.dat r]
               }
             blue&white {
                set colmax 230
                set colmin 100
                set id [open $install_dir/colors/bluewhite.dat r]
               }
             green&white {
                set colmax 230
                set colmin 100
                set id [open $install_dir/colors/greenwhite.dat r]

               }
	     green&red {
                set colmax 200
                set colmin 30
                set id [open $install_dir/colors/prism.dat r]
		set upside 0
	     }
             "red temperature" {
                set colmax 230
                set colmin  0
                set id [open $install_dir/colors/redtemp.dat r]
               }
             prism {
                set colmax 200
                set colmin 30
                set id [open $install_dir/colors/prism.dat r]
               }
             prism243 {
                set colmax 243
                set colmin 0
                set id [open $install_dir/colors/prism.dat r]
               }

             default {
		set color(0) #B8B8F8
		set color(1) #DD0000
		set color(2) #00AA00
		set color(3) #EEEE00
		set color(4) #0000FF
		set color(5) #AA00AA
		set color(6) #eb8000
		set color(7) #e623ff
		set color(8) #bd4b00
		set color(9) #8f7700
		set color(10) #659f00
		set color(11) #37cb00
		set color(12) #0df300
		set color(13) #00df26
		set color(14) #00b74d
		set color(15) #008a77
		set color(16) #00629e
		set color(17) #0035c8
		set color(18) #000def
		set color(19) #0000e3
		set color(20) #0000bb
		set color(21) #00008e
		set color(22) #000066
		set color(23) #000039
		set color(24) #000011
		return
		}
             }

set colstep [expr ($colmax - $colmin)/($ncolors+1)]

set k 0
set j 1
while {[gets $id line] >=0} {
  set r [format "%x" [lindex $line 0]]
  if {[string length $r] <2} {set r 0$r}

  set g [format "%x" [lindex $line 1]]
  if {[string length $g] <2} {set g 0$g}

  set b [format "%x" [lindex $line 2]]
  if {[string length $b] <2} {set b 0$b}

  if {$j >= [expr $colstep+$colmin]} {
     set color($k) #$r$g$b
     incr k
     set j [expr $j - $colstep]
  }
  incr j
}
close $id

# Reihenfolge drehen
if {$upside==0} {
  set num [expr $k-1]
  foreach index [array names color] {
     set temp($index) $color($index)
}

  foreach index [array names color] {
     set color($index) $temp([expr $num-$index])
}
}

}

