# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc init_parabel {} {
global bifu_par pcan which
global bxmin bxmax bxdelt bpxmin bpxdelt
global bymin bymax bydelt bpymin bpydelt
global ulx uly lrx lry boldxsize boldysize
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global commandy functiony a xanf xend

global timeplot


.parabel.plot delete all

set parlist ""
set idlist ""

# wird für commandy gebraucht
set a $bifu_par

if ![info exist xanf] {set xanf 0.0}
if ![info exist xend] {set xend 2.0}

set res [expr ($xend-$xanf)/100.0]

set ulx 0
set uly 0
set lrx $pcan
set lry $pcan 
set boldxsize $pcan
set boldysize $pcan


set bpxmin 0
set bpxdelt $pcan
set bpymin $pcan
set bpydelt -$pcan


set bxmin $xanf
set bxmax $xend 
set bymin $bxmin
set bymax $bxmax 

set commandy [makecommand $functiony]

#Achsen
set item [.parabel.plot create text [expr $pcan/2] 20 -text "Parameter: $bifu_par" \
             -font $boldFontN -anchor c]

for {set x $xanf} {$x<=$xend} {set x [expr $x +$res]} {

     set y $x
     set y [expr $commandy]

  if {$y>=0} {
    set bymin [min $bymin $y]
    set bymax [max $bymax $y]
    
    lappend idlist  $x
    lappend parlist $y
  } 

}

set bxmin $bymin
set bxmax $bymax
set bydelt [expr 1.0*($bymax -$bymin)] 
set bxdelt $bydelt 

set bidlist ""
set bparlist ""
set k 0
foreach x $idlist {
   lappend bidlist [bnnx $x] [bnny $x]
   lappend bparlist [bnnx $x] [bnny [lindex $parlist $k]]
   incr k

}

.parabel.plot create line $bidlist
.parabel.plot create line $bparlist

}
