# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc parabel {} {
global bifu_par pcan parsteps cut
global boldFontN textFont
global xanf xend
global can
global timeplot

set xanf 0.0
set xend 1.5

set bifu_par [pnnx [expr 1.0*$bifu_par]]
set parsteps 100
set cut 0

if ![winfo exist .parabel] {
 toplevel .parabel
 wm title .parabel {Parabel Set}
 wm geometry .parabel "+20+0"
 wm protocol .parabel WM_DELETE_WINDOW {.parabel.buttons.exit invoke}

  set pcan [expr $can -100]
  
  canvas .parabel.plot  -bg white -width $pcan -height $pcan
  pack .parabel.plot

  bind .parabel.plot <Motion> "set xc %x; set yc %y;bsetcoo"
  bind .parabel.plot <1> "itemMark .parabel.plot %x %y; set julx %x; set july %y; calc_parabel 1;"
  bind .parabel.plot <2> "set next 1"
  bind .parabel.plot <3> "itemMark .parabel.plot %x %y; set julx %x; set july %y; calc_parabel"
  
  
frame .parabel.x
pack .parabel.x

label .parabel.x.min -text xmin -font $boldFontN
pack .parabel.x.min -side left -pady 5 -padx 5

entry .parabel.x.emin -width 10 -relief sunken \
           -textvariable xanf -font $textFont
pack .parabel.x.emin -side left -pady 5 -padx 5

label .parabel.x.max -text xmax -font $boldFontN
pack .parabel.x.max -side left -pady 5 -padx 5

entry .parabel.x.emax -width 10 -relief sunken \
           -textvariable xend -font $textFont
pack .parabel.x.emax -side left -pady 5 -padx 5
 
button .parabel.x.redraw -text Redraw -command {init_parabel} -font $boldFontN
pack    .parabel.x.redraw -side left
  

scale .parabel.slid -from 0 -to 400\
      -variable parsteps \
      -length 200 \
      -orient horizontal -label "Iteration steps"       \
      -tickinterval 100 -showvalue true -resolution 1 \
      -bigincrement 200 -font $boldFontN

pack .parabel.slid -fill x -side left


frame .parabel.buttons
pack  .parabel.buttons

checkbutton .parabel.buttons.anf -text "cut first values" -variable cut -font $boldFontN
pack .parabel.buttons.anf -fill x -side left
checkbutton .parabel.buttons.tp -text {Time Plot}  -font $boldFontN \
       -variable timeplot
pack .parabel.buttons.tp -fill x -side left -padx 10

  button  .parabel.buttons.save -text {Print} -command {printout .parabel.plot} -font $boldFontN
  pack    .parabel.buttons.save -side left 
  
  button  .parabel.buttons.exit -text {Close} -command {destroy .parabel;destroy .timebifu;wm deiconify .ov; raise .ov} -font $boldFontN
  pack    .parabel.buttons.exit -side left 
  
  init_parabel
 if {$timeplot==1} {bifu_timeplot}
raise .parabel

} 
raise .parabel
}


