# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc drag_plot {xanf yanf xend yend direc} {
global nmax mode
global ran
set c .ov.plot

set edw2 [expr 1/sqrt(2)]
set pi4 [expr atan(1)]

set xdelt [expr pow($edw2,$nmax)*($xend-$xanf)]
set ydelt [expr pow($edw2,$nmax)*($yend-$yanf)]

set si [expr sin($direc*$pi4)]
set co [expr cos($direc*$pi4)]

set xneu [expr $xanf+ $co*$xdelt -$si*$ydelt]
set yneu [expr $yanf+ $si*$xdelt +$co*$ydelt]


set item [eval {$c create line} [nnx $xanf] [nny $yanf] \
                                [nnx $xneu] [nny $yneu]]
$c addtag curve withtag $item
update
set xdelt [expr $xneu-$xanf]
set ydelt [expr $yneu-$yanf]
set xalt $xneu
set yalt $yneu

set len [llength $ran]

for {set i 0} {$i<$len} {incr i} {

   set richt [lindex $ran $i]

   set xneu [expr  $xalt +$richt*$ydelt]
   set yneu [expr  $yalt -$richt*$xdelt]
 
   set item [eval {$c create line} [nnx $xalt] [nny $yalt] \
                                   [nnx $xneu] [nny $yneu]]
   $c addtag curve withtag $item
   update

   set xdelt [expr $xneu-$xalt]
   set ydelt [expr $yneu-$yalt]
   set xalt $xneu
   set yalt $yneu
}

#set item [eval {$c create line} [nnx $xalt] [nny $yalt] \
#                                   [nnx $xend] [nny $yend]]
$c addtag curve withtag $item
update
}

proc calc_dragon {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global ran count
global can

set count 0
set xanf 0
set yanf 0
set xend 1
set yend 0

set xmin -0.5
set xdelt 2.0
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -1.0
set ydelt 2.0

erase .ov.plot all

set ran {}
set richt 1
set direc 0
switch $mode {
random {
        set richt 1
        for {set i 1} {$i<=$nmax} {incr i} {
          set richt [expr [random]-0.5]
          if {$richt>0} {set richt 1} else {set richt -1}
          set len [llength $ran]
          lappend ran $richt
          set direc [expr $direc+$richt]
          for {set j 0} {$j<$len} {incr j} {
            set help [lindex $ran [expr $len-$j-1]]
            lappend ran [expr -1*$help]
          }
        }
       }

alternate {
        set richt 1
        for {set i 1} {$i<=$nmax} {incr i} {
          set richt [expr $richt*-1]
          set len [llength $ran]
          lappend ran $richt
          set direc [expr $direc+$richt]
          for {set j 0} {$j<$len} {incr j} {
            set help [lindex $ran [expr $len-$j-1]]
            lappend ran [expr -1*$help]
          }
        }
       }

right {
       for {set i 1} {$i<=$nmax} {incr i} {
         set richt 1
         set len [llength $ran]
         lappend ran $richt
          set direc [expr $direc+$richt]
         for {set j 0} {$j<$len} {incr j} {
            set help [lindex $ran [expr $len-$j-1]]
            lappend ran [expr -1*$help]
         }
       }
      }

left  {
       for {set i 1} {$i<=$nmax} {incr i} {
         set richt -1
         set len [llength $ran]
         lappend ran $richt
          set direc [expr $direc+$richt]
         for {set j 0} {$j<$len} {incr j} {
            set help [lindex $ran [expr $len-$j-1]]
            lappend ran [expr -1*$help]
         }
       }
      }
}

drag_plot $xanf $yanf $xend $yend $direc


set item [.ov.plot create text [expr $can/2] 20 -text "Highway dragon" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax iterations, mode: $mode" \
             -font $plotFontS -anchor c]

}



