# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc it_koch {number xanf yanf xend yend} {
global nmax mode
global w3h
global help

set c .ov.plot

if {$number >= $nmax} { 

    set item [eval {$c create line} [nnx $xanf] [nny $yanf]  [nnx $xend] [nny $yend] -tag curve]
    

    update

} else {
   set xdelt [expr ($xend-$xanf)/3.0]
   set ydelt [expr ($yend-$yanf)/3.0]

   switch $mode {
     right     {set help 1}
     left      {set help -1}
     random    {set help [expr [random]-0.5]}
     alternate {if [info exists help] { set help [expr $help*-1]
                                       } else {set help 1}}
   }

   if {$help > 0} {
      set xmid1 [expr $xanf+ $xdelt]
      set ymid1 [expr $yanf+ $ydelt]

      set xmd [expr $xmid1-$xanf]
      set ymd [expr $ymid1-$yanf]

      set xmid2 [expr $xmid1 + 0.5*$xmd - $w3h*$ymd]
      set ymid2 [expr $ymid1 + $w3h*$xmd + 0.5*$ymd]

      set xmid3 [expr $xanf+ 2.0*$xdelt]
      set ymid3 [expr $yanf+ 2.0*$ydelt]

   } else {
      set xmid1 [expr $xanf+ $xdelt]
      set ymid1 [expr $yanf+ $ydelt]

      set xmd [expr $xmid1-$xanf]
      set ymd [expr $ymid1-$yanf]

      set xmid2 [expr $xmid1 + 0.5*$xmd + $w3h*$ymd]
      set ymid2 [expr $ymid1 - $w3h*$xmd + 0.5*$ymd]

      set xmid3 [expr $xanf+ 2.0*$xdelt]
      set ymid3 [expr $yanf+ 2.0*$ydelt]
   }

   incr number
   it_koch $number $xanf $yanf $xmid1 $ymid1
   it_koch $number $xmid1 $ymid1 $xmid2 $ymid2
   it_koch $number $xmid2 $ymid2 $xmid3 $ymid3
   it_koch $number $xmid3 $ymid3 $xend $yend
}
}

proc calc_koch {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global w3h
global can

set w3h [expr sqrt(3)/2.0]

set xanf 0
set yanf -0.25
set xend 1
set yend -0.25

set xmid 0.5
set ymid [expr sqrt(3)/2.-0.25]

set xmin -0.5
set xdelt 2.0
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -1.0
set ydelt 2.0

erase .ov.plot all
     it_koch 0 $xend $yend $xanf $yanf 
     it_koch 0 $xanf $yanf $xmid $ymid
     it_koch 0 $xmid $ymid $xend $yend 


set item [.ov.plot create text [expr $can/2] 20 -text "Koch's Fractal" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax iterations, mode: $mode" \
             -font $plotFontS -anchor c]

}


