# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc quadrat {number xanf yanf xend yend} {
global nmax mode

set c .ov.plot

set item [eval {$c create line} [nnx $xanf] [nny $yanf] \
                                [nnx $xend] [nny $yend]]
set xdelt [expr ($xend-$xanf)]
set ydelt [expr ($yend-$yanf)]



set xp1 [expr $xanf-$ydelt]
set yp1 [expr $yanf+$xdelt]

set xp2 [expr $xp1 +$xdelt]
set yp2 [expr $yp1 +$ydelt]

set item [eval {$c create line} [nnx $xanf] [nny $yanf] \
                                [nnx $xp1] [nny $yp1]]

set item [eval {$c create line} [nnx $xend] [nny $yend] \
                                [nnx $xp2] [nny $yp2]]

set item [eval {$c create line} [nnx $xp1] [nny $yp1] \
                                [nnx $xp2] [nny $yp2]]

update
iterate $number $xp1 $yp1 $xp2 $yp2 

}

proc iterate {number xanf yanf xend yend} {
global nmax mode
global sinw1 cosw1 sinw2 cosw2

set xdelt [expr $cosw1*($xend-$xanf)]
set ydelt [expr $cosw1*($yend-$yanf)]

set len [expr $xdelt*$xdelt+$ydelt*$ydelt]

if {$number < $nmax && $len > 0.001} {


   set p1x [expr $xanf+($xdelt*$cosw1 - $ydelt*$sinw1)]
   set p1y [expr $yanf+($xdelt*$sinw1 + $ydelt*$cosw1)]
 
   incr number
   quadrat $number $xanf $yanf $p1x $p1y
   quadrat $number $p1x $p1y $xend $yend
 }
}

proc calc_pyth {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global sinw1 cosw1 sinw2 cosw2

global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global can

set xanf 0
set yanf 0
set xend 1
set yend 0

set xmin -5.0
set xdelt 10.0
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -1.
set ydelt 10.0

set pi [expr 4*atan(1.0)]

set winkel 25.
set winkel1 [expr $pi*$winkel/180.]
set winkel2 [expr $pi/2.-$winkel1]

set sinw1 [expr sin($winkel1)]
set cosw1 [expr cos($winkel1)]

set sinw2 [expr sin($winkel2)]
set cosw2 [expr cos($winkel2)]
erase .ov.plot all

set item [.ov.plot create text [expr $can/2] 20 -text "Pythagoras' tree" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax iterations" \
             -font $plotFontS -anchor c]

quadrat 1 $xanf $yanf $xend $yend
}


