# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_newton {} {
global xmin xmax ymin ymax
global nmax
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global exec_dir storedir install_dir
global ulx uly lrx lry oldxsize oldysize
global scal
global start
global iter
global bindflag
global can

#set can 600
set c .ov.plot


if ![info exists ulx] {
   set ulx 50
   set uly 50
   set lrx [expr $can-50]
   set lry [expr $can-50] 
   set oldxsize [expr $can-100] 
   set oldysize [expr $can-100] 
}

if { $bindflag == 1 } {
set ulx [expr $ulx-50]
set uly [expr $uly-50]
set lrx [expr $lrx-50]
set lry [expr $lry-50]
set bindflag 0
}

erase $c all

set item [.ov.plot create text [expr $can/2]  20 -text "Newton Roots" \
             -font $boldFontN -anchor c]

#set uly [expr 500-$uly]
#set lry [expr 500-$lry]
if ![file exists $storedir/temp] {file mkdir $storedir/temp}
set scal [exec $exec_dir/newton $xmin $xmax $ymin $ymax $ulx $lrx $uly $lry $oldxsize $oldysize $iter [expr $can - 100] $install_dir/colors/redtemp.dat $storedir/temp/newton.ppm]

set xmin [lindex $scal 0]
set xmax [lindex $scal 1]
set ymin [lindex $scal 2]
set ymax [lindex $scal 3]
set oldxsize [lindex $scal 4]
set oldysize [lindex $scal 5]
set ulx 0
set uly 0
set lrx $oldxsize
set lry $oldysize

set item [.ov.plot create text  [expr $can/2]  [expr $can-20] -text "xmin=$xmin  ymin=$ymin  xmax=$xmax  ymax=$ymax" \
             -font $plotFontS -anchor c]

image create photo newton -gamma 3.0 -file $storedir/temp/newton.ppm

set item [$c create image 50 50 -image newton -anchor nw]

update





}


