# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc plotControl {} {
global can ovc smallscreen
global stop
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global plotmode agrflag
set agrflag 0
set ovc .ov.right.control
frame $ovc
pack $ovc

global function fname showfunc plotmode fanz
global remminx remminy remmaxx remmaxy remmint remmaxt
global minx miny maxx maxy mint maxt
global eminx eminy emaxx emaxy 

global cc
set cc 1
global showcoor
global a b c d e

set showcoor 0

if ![info exist plotmode] {set plotmode 1;eval_plotmode 1}
if ![info exist mint] {set mint 0.0}
if ![info exist maxt] {set maxt 10.0}
if ![info exist minx] {set minx -10.0}
if ![info exist maxx] {set maxx 10.0}
if ![info exist miny] {set miny -10.0}
if ![info exist maxy] {set maxy 10.0}


set remmint 0.0
set remmaxt 10.0
set remminx -10.0
set remmaxx 10.0
set remminy -10.0
set remmaxy 10.0

if {$plotmode==2} {
set remminx -3.0
set remmaxx 3.0
set remminy -3.0
set remmaxy 3.0
}




set minpart $mint
set maxpart $maxt
set minparx $minx
set maxparx $maxx
set minpary $miny
set maxpary $maxy

if ![info exist eminx] {set eminx $minx}
if ![info exist emaxx] {set emaxx $maxx}
if ![info exist eminy] {set eminy $miny}
if ![info exist emaxy] {set emaxy $maxy}

if ![info exist a] {set a 1.0}
if ![info exist b] {set b 1.0}
if ![info exist c] {set c 1.0}
if ![info exist d] {set d 1.0}
if ![info exist e] {set e 1.0}


init_plot
textdel



frame $ovc.left
pack $ovc.left 

frame $ovc.left.mode
pack $ovc.left.mode 

button $ovc.left.mode.1d -text {1D} \
      -font $boldFontN -command {set plotmode 1;eval_plotmode $plotmode;destroy $ovc;plotControl}
pack $ovc.left.mode.1d -fill x -side left

button $ovc.left.mode.p2d -text {2D} \
       -font $boldFontN -command {set plotmode 0;eval_plotmode $plotmode;destroy $ovc;plotControl}
pack $ovc.left.mode.p2d -fill x -side left

button $ovc.left.mode.lin -text {Linear} \
       -font $boldFontN -command {set plotmode 2;eval_plotmode $plotmode;destroy $ovc;plotControl}
pack $ovc.left.mode.lin -fill x -side left


for {set i 1} {$i <=$fanz} {incr i} {
   frame $ovc.left.func$i
   pack $ovc.left.func$i
   
   checkbutton $ovc.left.func$i.but -variable showfunc($i) -font $boldFontN
   pack $ovc.left.func$i.but -side left

   label $ovc.left.func$i.fl -text "$fname($i)" -font $boldFontN
   pack $ovc.left.func$i.fl -side left

   entry $ovc.left.func$i.fex -width 40 -relief sunken \
           -textvariable function($i) -font $boldFontN
   pack $ovc.left.func$i.fex -side left -pady 10
   if {$plotmode==2} {$ovc.left.func$i.fex config -state disabled}

}
if {$plotmode==2} {

   global vecx vecy object
   if ![info exist object] {set  object square}
   frame $ovc.left.obj
   pack $ovc.left.obj
   radiobutton $ovc.left.obj.square -text "Square" -variable object -value square -command square
   pack $ovc.left.obj.square -side left
   radiobutton $ovc.left.obj.vector -text "Vector" -variable object -value vector -command vector
   pack $ovc.left.obj.vector -side left

   bind .ov.plot <Motion> "set xc %x; set yc %y;setcoo"
   bind .ov.plot <2> "itemMark .ov.plot %x %y; set vecx(0) %x; set vecy(0) %y"
   bind .ov.plot <B2-Motion> "itemLine .ov.plot %x %y; set vecx(1) %x; set vecy(1) %y"

   textinfo "Select Square or vector to initialize"
   textinfo "Middle Mouse Button sets Vector"

   $ovc.left.obj.$object invoke
} 

bind .ov.plot <Shift-1> "itemMark .ov.plot %x %y; set ulx %x; set uly %y; \
set cminx %x;set cminy %y;set cmaxx %x;set cmaxy %y;scalcoo"
bind .ov.plot <Shift-B1-Motion> "itemStroke .ov.plot %x %y; set lrx %x; set lry %y;  \
set cmaxx %x;set cminy %y;scalcoo"
bind .ov.plot <Shift-3> "scaleaxes $plotmode;.com.file.ok invoke"

textinfo "Shift Left Mouse Button creates scaling rectangle in canvas"
textinfo "Shift Right Mouse Button scales"


# PARAMETER
###########

frame $ovc.left.par
pack $ovc.left.par -pady 5

label $ovc.left.par.la -text "a=" -font $boldFontN
pack $ovc.left.par.la -side left
entry $ovc.left.par.a -width 5 -relief sunken \
           -textvariable a -font $boldFontN
pack $ovc.left.par.a -side left

label $ovc.left.par.lb -text "b=" -font $boldFontN
pack $ovc.left.par.lb -side left
entry $ovc.left.par.b -width 5 -relief sunken \
           -textvariable b -font $boldFontN
pack $ovc.left.par.b -side left


label $ovc.left.par.lc -text "c=" -font $boldFontN
pack $ovc.left.par.lc -side left
entry $ovc.left.par.c -width 5 -relief sunken \
           -textvariable c -font $boldFontN
pack $ovc.left.par.c -side left

label $ovc.left.par.ld -text "d=" -font $boldFontN
pack $ovc.left.par.ld -side left
entry $ovc.left.par.d -width 5 -relief sunken \
           -textvariable d -font $boldFontN
pack $ovc.left.par.d -side left



label $ovc.left.par.le -text "e=" -font $boldFontN
pack $ovc.left.par.le -side left
entry $ovc.left.par.e -width 5 -relief sunken \
           -textvariable e -font $boldFontN
pack $ovc.left.par.e -side left

# label $ovc.left.par.la -text "a=" -font $boldFontN
# pack $ovc.left.par.la -side left
# entry $ovc.left.par.a -width 5 -relief sunken \
#            -textvariable a -font $boldFontN
# pack $ovc.left.par.a -side left
# 
# label $ovc.left.par.lb -text "b=" -font $boldFontN
# pack $ovc.left.par.lb -side left
# entry $ovc.left.par.b -width 5 -relief sunken \
#            -textvariable b -font $boldFontN
# pack $ovc.left.par.b -side left
# 
# label $ovc.left.par.lc -text "c=" -font $boldFontN
# pack $ovc.left.par.lc -side left
# entry $ovc.left.par.c -width 5 -relief sunken \
#            -textvariable c -font $boldFontN
# pack $ovc.left.par.c -side left
# 
# label $ovc.left.par.ld -text "d=" -font $boldFontN
# pack $ovc.left.par.ld -side left
# entry $ovc.left.par.d -width 5 -relief sunken \
#            -textvariable d -font $boldFontN
# pack $ovc.left.par.d -side left
# 
# label $ovc.left.par.le -text "e=" -font $boldFontN
# pack $ovc.left.par.le -side left
# entry $ovc.left.par.e -width 5 -relief sunken \
#            -textvariable e -font $boldFontN
# pack $ovc.left.par.e -side left

# SLIDER
########
if {$plotmode==0} {
label $ovc.left.lt -text "Time t" -font $boldFontN -anchor w
pack $ovc.left.lt -fill x
Scale2 $ovc.left.t $mint $maxt $minpart $maxpart 350 10
pack $ovc.left.t -fill x -pady 5

Scale2init $ovc.left.t $minpart lbox
Scale2invoke $ovc.left.t $mint lbox
Scale2init $ovc.left.t $maxpart rbox
Scale2invoke $ovc.left.t $maxt rbox

}

# 
# frame $ovc.left.1
# pack $ovc.left.1 -pady 5
# label $ovc.left.1.lx -text "X Coordinates" -font $boldFontN -anchor w
# pack $ovc.left.1.lx -side left
# entry $ovc.left.1.exmin -width 5 -font $boldFontN -textvariable eminx
# if {$smallscreen==0} {pack $ovc.left.1.exmin -side left -padx 5 }
# bind $ovc.left.1.exmin <Return> "facLoad"
# 
# # 
# # Scale2 $ovc.left.1.x $minx $maxx $minparx $maxparx 250 10
# # if {$smallscreen==0} {pack $ovc.left.1.x  -pady 5 -side left}
# # 
# # Scale2init $ovc.left.1.x $minparx lbox
# # Scale2invoke $ovc.left.1.x $minx lbox
# # Scale2init $ovc.left.1.x $maxparx rbox
# # Scale2invoke $ovc.left.1.x $maxx rbox
# 
# 
# Scale2 $ovc.left.1.x $minx $maxx $eminx $emaxx 250 10
# if {$smallscreen==99} {pack $ovc.left.1.x  -pady 5 -side left}
# Scale2init $ovc.left.1.x $eminx lbox
# Scale2invoke $ovc.left.1.x $minx lbox
# Scale2init $ovc.left.1.x $emaxx rbox
# Scale2invoke $ovc.left.1.x $maxx rbox
# 
# entry $ovc.left.1.exmax -width 5 -font $boldFontN -textvariable emaxx
# if {$smallscreen==0} {pack $ovc.left.1.exmax -side left -padx 5}
# bind $ovc.left.1.exmax <Return> "facLoad"
# 
# 
# 
# frame $ovc.left.2
# pack $ovc.left.2 -pady 5
# label $ovc.left.2.ly -text "Y Coordinates" -font $boldFontN -anchor w
# pack $ovc.left.2.ly -side left
# 
# entry $ovc.left.2.eymin -width 5 -font $boldFontN -textvariable eminy
# if {$smallscreen==0} {pack $ovc.left.2.eymin -side left  -padx 5}
# bind $ovc.left.2.eymin <Return> "facLoad"
# 
# 
# 
# Scale2 $ovc.left.2.y $miny $maxy $eminy $emaxy 250 10
# if {$smallscreen==99} {pack $ovc.left.2.y   -pady 5 -side left}
# Scale2init $ovc.left.2.y $eminy lbox
# Scale2invoke $ovc.left.2.y $miny lbox
# Scale2init $ovc.left.2.y $emaxy rbox
# Scale2invoke $ovc.left.2.y $maxy rbox
# 
# 
# entry $ovc.left.2.eymax -width 5 -font $boldFontN -textvariable emaxy
# if {$smallscreen==0} {pack $ovc.left.2.eymax -side left -padx 5}
# bind $ovc.left.2.eymax <Return> "facLoad"



# COMMANDS
##########

frame $ovc.right
pack $ovc.right

frame $ovc.right.bottom
pack $ovc.right.bottom -side bottom

frame $ovc.right.misc
pack $ovc.right.misc -side bottom

button $ovc.right.misc.tp -text {Plot} \
       -command {plot $plotmode}  -font $boldFontN
pack $ovc.right.misc.tp -fill x -side left

button $ovc.right.misc.scale -text {Scale} \
       -command {scaleaxes $plotmode}  -font $boldFontN
pack $ovc.right.misc.scale -fill x -side left

button $ovc.right.misc.rscale -text {ReSetScale} \
       -command {resetscale}  -font $boldFontN
pack $ovc.right.misc.rscale -fill x -side left

button $ovc.right.misc.ascale -text {Autoscale} \
       -command {autoscale}  -font $boldFontN
pack $ovc.right.misc.ascale -fill x -side left

button $ovc.right.misc.pscale -text {PosScale} \
       -command {resetscale 1}  -font $boldFontN
pack $ovc.right.misc.pscale -fill x -side left


# button $ovc.right.misc.reset -text {Clear} \
#        -command {.ov.plot delete all;eval_plotmode $plotmode;destroy $ovc;plotControl} -font $boldFontN
# pack $ovc.right.misc.reset -fill x -side left

button $ovc.right.misc.reset -text {Clear} \
       -command {.ov.plot delete all;destroy $ovc;plotControl} -font $boldFontN
pack $ovc.right.misc.reset -fill x -side left

checkbutton $ovc.right.bottom.coor -text {Show coor.} \
       -variable showcoor -font $boldFontN
pack $ovc.right.bottom.coor -fill x -side left

button $ovc.right.bottom.ps -text {PS print} \
       -command {printout} -font $boldFontN
pack $ovc.right.bottom.ps -fill x -side left

button $ovc.right.bottom.agr -text {Grace print} \
       -command {printout_grace} -font $boldFontN
pack $ovc.right.bottom.agr -fill x -side left



}


proc facLoad { } {
global eminx minx  emaxx maxx
global eminy miny emaxy maxy
global ovc
global toolflag

set minx $eminx
set maxx $emaxx
set miny $eminy
set maxy $emaxy


	destroy $ovc
	switch $toolflag {
	  "plot" {plotControl;$ovc.right.misc.tp invoke}
	  "slope" {slopeControl;$ovc.sim.calc invoke}
	}


}


