# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc plotlinear {} {
global can
global tmin tmax
global xmin xmax xdelt pxmin pxmax pxdelt
global ymin ymax ydelt pymin pymax pydelt
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global function command fname
global a b c d e
global axmin axmax aymin aymax
global vecx vecy




set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]

set_plot

set color(1) black
set color(2) red
set color(3) seagreen
set color(4) orange

set width 2

set yval 0
set yoff 20

axes

set axmin inf
set axmax -inf
set aymin inf
set aymax -inf


#Einheitsquadrat

set vecx(0) 0
set vecy(0) 0

set vecx(1) 1
set vecy(1) 0

set vecx(2) 1
set vecy(2) 1

set vecx(3) 0
set vecy(3) 1


 .ov.plot create rect [nnx $vecx(0)] [nny $vecy(0)]    [nnx $vecx(2)] [nny $vecy(2)]   \
                      -tag richt -fill lightgrey

for {set i 0} {$i<=3} {incr i} {

  set j [expr int(fmod($i+1,4))]
 .ov.plot create line [nnx $vecx($i)] [nny $vecy($i)]  [nnx $vecx($j)] [nny $vecy($j)]  -tag richt -fill $color([expr $i+1]) -width $width -arrow last
}


set command(1) [makecommand $function(1)]
set command(2) [makecommand $function(2)]


for {set i 0} {$i<=3} {incr i} {

    set x $vecx($i)
    set y $vecy($i)

    set imgx($i) [expr double($command(1))]
    set imgy($i) [expr double($command(2))]

    set axmin [min $axmin $x]
    set axmax [max $axmax $x]
    set aymin [min $aymin $y]
    set aymax [max $aymax $y]
     

    set j [expr int(fmod($i+1,4))]
    set x $vecx($j)
    set y $vecy($j)

    set imgx($j) [expr double($command(1))]
    set imgy($j) [expr double($command(2))]


    .ov.plot create line [nnx $imgx($i)] [nny $imgy($i)] [nnx $imgx($j)] [nny $imgy($j)]  -tag richt -fill $color([expr $i+1]) -width $width -arrow last


    set axmin [min $axmin $x]
    set axmax [max $axmax $x]
    set aymin [min $aymin $y]
    set aymax [max $aymax $y]
     

}
set EW [calc_ew $a $b $c $d]
set sp [lindex $EW 4]
set det [lindex $EW 5]

#.ov.plot create poly [nnx $imgx(1)] [nny $imgy(1)]  [nnx $imgx(2)] [nny $imgy(2)]  [nnx $imgx(2)] [nny $imgy(2)]  [nnx $imgx(2)] [nny $imgy(2)] \
 #                      -tag richt -fill $color(2) -width $width
   
   
 set yval [expr $yval+$yoff]
.ov.plot create text 10 [expr $yval+$yoff] -text "$a $b"  -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+2*$yoff] -text "$c $d" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+3*$yoff] -text "spur = $sp " -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+4*$yoff] -text "det = $det" -font $boldFontN -anchor w -tag title

}


