# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_iso {{which 0}} {
global can ovc
global xmin xmax xdelt pxmin pxdelt
global ymin ymax ydelt pymin pydelt
global maxsteps maxstep minlambda maxlambda
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global functionx commandx functiony commandy
global maxsteps maxstep
global minx maxx miny maxy
global a b c d e
global acc
global t0

set xcolor green
set ycolor blue
set width 2

set ZERO $acc

# set minx [lindex [Scale2Value $ovc.left.x] 0]
# set maxx [lindex [Scale2Value $ovc.left.x] 1]
# set miny [lindex [Scale2Value $ovc.left.y] 0]
# set maxy [lindex [Scale2Value $ovc.left.y] 1]


set xmin $minx
set xmax $maxx
set ymin $miny
set ymax $maxy

set xdelt [expr $xmax -$xmin]
set ydelt [expr $ymax -$ymin]

set fac 2
set isosteps [expr $maxstep*$fac]

set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can

set commandx [makecommand $functionx]
set commandy [makecommand $functiony]

set dxc [expr double($xdelt/$isosteps)]
set dyc [expr double($ydelt/$isosteps)]

set t $t0
set xlist ""
set ylist ""

for {set i 0} {$i<=[expr $isosteps]} {incr i} {

  set x [expr double($xmin +$i*$dxc)]
  for {set j 0} {$j<=[expr $isosteps]} {incr j} {

    set y [expr double($ymin +$j*$dyc)]

    set xstrich [expr double($commandx)]
    set ystrich [expr double($commandy)]


# x-Isokline
    if {[expr abs($xstrich)]<= [expr $ZERO*abs($x*$y)] && ($which == "x" || $which == "xy")} {

#        set item [.ov.plot create line [nnx $x] [expr [nny $y]-2] [nnx $x]  [expr [nny $y]+2]\
#                        -tag richt -tag xx -fill $xcolor -width $width]
# 		       .ov.plot lower $item
       lappend xlist [nnx $x] [nny $y]


    }

# y-Isokline

    if {[expr abs($ystrich)]<= [expr $ZERO*abs($x*$y)] && ($which == "y" || $which == "xy")} {

# 	  set item [.ov.plot create line [expr [nnx $x]-2] [nny $y]  [expr [nnx $x]+2] [nny $y]\
#                        -tag richt -tag xx -fill $ycolor -width $width]
# 		       .ov.plot lower $item
          lappend ylist [nnx $x] [nny $y]
    }

}
}

 if {$which == "x" || $which=="xy"} {
    .ov.plot create text 380 25 -text "x'=0"\
                   -font $boldFontN -anchor e -tag title -fill $xcolor
    if {$xlist !=""} {
       set item [.ov.plot create line $xlist -tag richt -tag xx -fill $xcolor -width 1]
	      #.ov.plot lower $item
    } else {
       textinfo "No x-isocline found"
    }
 }

 if {$which == "y" || $which=="xy"} {
    .ov.plot create text 380 40 -text "y'=0"\
                   -font $boldFontN -anchor e -tag title -fill $ycolor

    if {$ylist !=""} {
      set item [.ov.plot create line $ylist -tag richt -tag xx -fill $ycolor -width 1]
	      #.ov.plot lower $item
    } else {
       textinfo "No y-isocline found"
    }


 }

  update
  update idletasks
}


