# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_linear_model {} {
global a b c d e
global functionx
global functiony

global remminx remminy remmaxx remmaxy
global EV1 EV2
global ovc
# Achsen symmetrisch machen
set remminx -$remmaxx
set remminy -$remmaxy
resetscale
#reset

set form "%3.2f"
set functionx "a*x+b*y"
set functiony "c*x+d*y"

set e ""

if {$a=="" || $b=="" | $c=="" | $d==""} {
   textdel
   textinfo "Parameter missing !!"
   return
}

set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]

set EW [calc_ew $a $b $c $d]
set EW1 [lindex $EW 0]
set EW2 [lindex $EW 1]

set EV1 [lindex $EW 2]
set EV2 [lindex $EW 3]

set sp [lindex $EW 4]
set det [lindex $EW 5]

textdel
textinfo "A="
textinfo "   [format $form $a] [format $form $b]                spA=  [format $form $sp] "
textinfo "   [format $form $c] [format $form $d]               detA = [format $form $det]"

textinfo "Eigenwert 1:   $EW1      Eigenvektor 1: $EV1"
textinfo "Eigenwert 2:   $EW2      Eigenvektor 2: $EV2"

calc_slope

$ovc.iso.er config -state normal

}
