# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc slopeControl {} {
global can
global stop
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global ovc

#toplevel .ovc
#wm title .ovc { Control panel }
#wm geometry $ovc "+660+300"

set ovc .ov.right.control

frame $ovc
pack $ovc

global functionx functiony
global maxsteps maxstep endtime timeplot showpoints slopeplot showcoor
global minx maxx miny maxy
global remminx remminy remmaxx remmaxy
global i0 j0 t0 x0 y0
global offsetx offsety

global a b c d e
global acc delt

set offsetx 0
set offsety 0
set nmax 0
set stop 0
set t0 0
set showcoor 0
if ![info exist slopeplot] {set slopeplot 1}

if ![info exist minx] {set minx -1.0}
if ![info exist maxx] {set maxx 5.0}
if ![info exist miny] {set miny -1.0}
if ![info exist maxy] {set maxy 5.0}
set remminx -1.0
set remmaxx 5.0
set remminy -1.0
set remmaxy 5.0


# if ![info exist maxsteps] {set maxsteps 25}
# if ![info exist endtime] {set endtime 50}
if ![info exist a] {set a 1.0}
if ![info exist b] {set b 1.0}
if ![info exist c] {set c 1.0}
if ![info exist d] {set d 1.0}
if ![info exist e] {set e 1.0}
if ![info exist acc] {set acc 0.001}
if ![info exist delt] {set delt 0.01}

set minparx $minx
set maxparx $maxx
set minpary $miny
set maxpary $maxy

set maxsteps 25
set endtime 50
set maxstep 100
set maxtime 1000
set timeplot 0
set showpoints 0
set tick 1
set big 1

init_slope
bind .ov.plot <1> "itemMark .ov.plot %x %y; set i0 %x; set j0 %y;init_solver;start_solver rk"
bind .ov.plot <2> "itemMark .ov.plot %x %y; set i0 %x; set j0 %y;init_solver;start_solver euler"
bind .ov.plot <3> "set stop 1;raisewindows"
bind .ov.plot <Motion> "set xc %x; set yc %y;setcoo"


bind .ov.plot <Shift-1> "itemMark .ov.plot %x %y; set ulx %x; set uly %y; \
set cminx %x;set cminy %y;set cmaxx %x;set cmaxy %y;scalcoo"
bind .ov.plot <Shift-B1-Motion> "itemStroke .ov.plot %x %y; set lrx %x; set lry %y;  \
set cmaxx %x;set cminy %y;scalcoo"
bind .ov.plot <Shift-3> "scaleaxes 1;.com.file.ok invoke"
textinfo "Shift Left Mouse Button creates scaling rectangle in canvas"
textinfo "Shift Right Mouse Button scales"
textinfo "Right mouse button stops simulation"


frame $ovc.left
pack $ovc.left 

if ![info exist functionx] {set functionx 1}
if ![info exist functiony] {set functiony y}


# Initializing of sliders
#------------------------

frame $ovc.left.funcx
pack $ovc.left.funcx -fill x

label $ovc.left.funcx.flx -text "x'=" -font $boldFontN
pack $ovc.left.funcx.flx -side left

entry $ovc.left.funcx.fex -width 30 -relief sunken \
           -textvariable functionx -font $boldFontN
pack $ovc.left.funcx.fex -side left -pady 10

label $ovc.left.funcx.awlx -text "x0=" -font $boldFontN
pack $ovc.left.funcx.awlx -side left

entry $ovc.left.funcx.awx  -width 10 -relief sunken \
           -textvariable x0 -font $boldFontN
pack $ovc.left.funcx.awx -side left

frame $ovc.left.funcy
pack $ovc.left.funcy -fill x

label $ovc.left.funcy.fly -text "y'=" -font $boldFontN
pack $ovc.left.funcy.fly -side left

entry $ovc.left.funcy.fey -width 30 -relief sunken \
           -textvariable functiony -font $boldFontN
pack $ovc.left.funcy.fey -side left -pady 10

label $ovc.left.funcy.awly -text "y0=" -font $boldFontN
pack $ovc.left.funcy.awly -side left

entry $ovc.left.funcy.awy  -width 10 -relief sunken \
           -textvariable y0 -font $boldFontN
pack $ovc.left.funcy.awy -side left


# Parameters
set wid 8

frame $ovc.left.par
pack $ovc.left.par -pady 10

label $ovc.left.par.la -text "a=" -font $boldFontN
pack $ovc.left.par.la -side left
entry $ovc.left.par.a -width $wid -relief sunken \
           -textvariable a -font $boldFontN
pack $ovc.left.par.a -side left

label $ovc.left.par.lb -text "b=" -font $boldFontN
pack $ovc.left.par.lb -side left
entry $ovc.left.par.b -width $wid -relief sunken \
           -textvariable b -font $boldFontN
pack $ovc.left.par.b -side left


label $ovc.left.par.lc -text "c=" -font $boldFontN
pack $ovc.left.par.lc -side left
entry $ovc.left.par.c -width $wid -relief sunken \
           -textvariable c -font $boldFontN
pack $ovc.left.par.c -side left

label $ovc.left.par.ld -text "d=" -font $boldFontN
pack $ovc.left.par.ld -side left
entry $ovc.left.par.d -width $wid -relief sunken \
           -textvariable d -font $boldFontN
pack $ovc.left.par.d -side left

label $ovc.left.par.le -text "e=" -font $boldFontN
pack $ovc.left.par.le -side left
entry $ovc.left.par.e -width $wid -relief sunken \
           -textvariable e -font $boldFontN
pack $ovc.left.par.e -side left

label $ovc.left.par.lf -text "f=" -font $boldFontN
#pack $ovc.left.par.lf -side left
entry $ovc.left.par.f -width $wid -relief sunken \
           -textvariable f -font $boldFontN
#pack $ovc.left.par.f -side left


# CONTROL
#########

frame $ovc.left.er
pack $ovc.left.er

button $ovc.left.er.calc -text "Calc Slope Field" -command {calc_slope} -font $boldFontN
pack $ovc.left.er.calc   -side left

button $ovc.left.er.reload -text "Reload" -command {
                                                      LoadFunc 3
                                                      slopeControl
                                                      resetscale
                                                      calc_slope

                                                      $ovc.left.er.mlinear config -state normal
                                                   } -font $boldFontN
pack $ovc.left.er.reload   -side left

button $ovc.left.er.mlinear  -font $boldFontN   \
-text "Make Linear" -command {make_linear}
pack $ovc.left.er.mlinear -side left


button $ovc.left.er.linear  -font $boldFontN   \
-text "Linear Model" -command {calc_linear_model}
pack $ovc.left.er.linear -side left




frame $ovc.sim
pack $ovc.sim -pady 10


button $ovc.sim.cawp -text "Initial value" -command {start_solver rk} -font $boldFontN
pack $ovc.sim.cawp  -side left

label $ovc.sim.ldelt -text "Delta" -font $boldFontN
pack $ovc.sim.ldelt -side left
entry $ovc.sim.delt -width 6 -relief sunken  -textvariable delt -font $boldFontN
pack $ovc.sim.delt -side left

label $ovc.sim.lacc -text "Acc." -font $boldFontN
pack $ovc.sim.lacc -side left
entry $ovc.sim.acc -width 6 -relief sunken  -textvariable acc -font $boldFontN
pack $ovc.sim.acc -side left


frame $ovc.iso
pack $ovc.iso -pady 10

button $ovc.iso.calcx -text "X isoclines" -command {calc_iso x} -font $boldFontN
pack $ovc.iso.calcx   -side left

button $ovc.iso.calcy -text "Y isoclines" -command {calc_iso y} -font $boldFontN
pack $ovc.iso.calcy   -side left

button $ovc.iso.calcxy -text "Isoclines" -command {calc_iso xy} -font $boldFontN
pack $ovc.iso.calcxy  -side left

button $ovc.iso.er  -font $boldFontN   \
-text "Eigenrichtung" -command {plot_eigenricht} -state disabled
pack $ovc.iso.er 


frame $ovc.right
pack $ovc.right

frame $ovc.right.bottom
pack $ovc.right.bottom -side bottom 

checkbutton $ovc.right.bottom.hs -text {Slope Field}  -font $boldFontN \
       -variable slopeplot
pack $ovc.right.bottom.hs -fill x -side left

checkbutton $ovc.right.bottom.tp -text {Time Plot}  -font $boldFontN \
       -variable timeplot
pack $ovc.right.bottom.tp -fill x -side left

checkbutton $ovc.right.bottom.coor -text {Show Coor.}  -font $boldFontN \
       -variable showcoor
pack $ovc.right.bottom.coor -fill x -side left

checkbutton $ovc.right.bottom.points -text {Show Points}  -font $boldFontN \
       -variable showpoints
pack $ovc.right.bottom.points -fill x -side left

frame $ovc.right.misc
pack $ovc.right.misc -side bottom 

button $ovc.right.misc.scale -text {Scale} \
       -command {scaleaxes 1}  -font $boldFontN
pack $ovc.right.misc.scale -fill x -side left

button $ovc.right.misc.rscale -text {ReSetScale} \
       -command {resetscale}  -font $boldFontN
pack $ovc.right.misc.rscale -fill x -side left

button $ovc.right.misc.ascale -text {Autoscale} \
       -command {autoscale}  -font $boldFontN
pack $ovc.right.misc.ascale -fill x -side left

button $ovc.right.misc.pscale -text {PosScale} \
       -command {resetscale 1}  -font $boldFontN
pack $ovc.right.misc.pscale -fill x -side left


# button $ovc.right.misc.reset -text {Reset Coor.}  -font $boldFontN \
#        -command {reset}
# pack $ovc.right.misc.reset -fill x -side left

button $ovc.right.misc.ps -text {PS print}  -font $boldFontN \
       -command {printout}
pack $ovc.right.misc.ps -fill x -side left





# label $ovc.left.lx -text "X Coordinates" -font $boldFontN -anchor w
# #pack $ovc.left.lx -fill x
# Scale2 $ovc.left.x $minx $maxx $minparx $maxparx 300 10
# #pack $ovc.left.x -fill x -pady 5
# 
# Scale2init $ovc.left.x $minparx lbox
# Scale2invoke $ovc.left.x $minx lbox
# Scale2init $ovc.left.x $maxparx rbox
# Scale2invoke $ovc.left.x $maxx rbox
# 
# label $ovc.left.ly -text "Y Coordinates" -font $boldFontN -anchor w
# #pack $ovc.left.ly -fill x
# Scale2 $ovc.left.y $miny $maxy $minpary $maxpary 300 10
# #pack $ovc.left.y -fill x -pady 5
# 
# Scale2init $ovc.left.y $minpary lbox
# Scale2invoke $ovc.left.y $miny lbox
# Scale2init $ovc.left.y $maxpary rbox
# Scale2invoke $ovc.left.y $maxy rbox

frame $ovc.left.num
pack $ovc.left.num -pady 10

scale $ovc.left.num.res -from 0 -to $maxstep\
      -variable maxsteps \
      -length 170 \
      -orient horizontal -label "Resolution"       \
      -tickinterval [expr $maxstep/4] -showvalue true -resolution 1 \
      -bigincrement [expr $maxstep/100]  -font $boldFontN  

pack $ovc.left.num.res -fill x  -side left

scale $ovc.left.num.endtime -from 0 -to $maxtime\
      -variable endtime \
      -length 170 \
      -orient horizontal -label "Endtime"       \
      -tickinterval [expr $maxtime/5] -showvalue true -resolution 1 \
      -bigincrement [expr $maxtime/100]  -font $boldFontN  

pack $ovc.left.num.endtime -fill x -side left

}


