# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc init_solver {} {
global i0 j0 x0 y0
global stop
global timeplot

set x0 [pnnx $i0]
set y0 [pnny $j0]
if {$timeplot==1} {timeplot}
}

# which euler oder rk
proc start_solver {which} {
global a b c d e
solver $which $a $b $c $d $e
}

proc solver {which a b c d e} {
global commandx commandy showcoor
global t0 x0 y0
global stop timeplot endtime
global axmin axmax aymin aymax ax0 ay0
global delt
global showpoints


set ax0 $x0
set ay0 $y0

set axmin inf
set axmax -inf
set aymin inf
set aymax -inf



set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]


.ov.plot create oval [expr [nnx $x0]-2] [expr [nny $y0]-2] [expr [nnx $x0]+2] [expr [nny $y0]+2] -fill red

if {$showcoor==1} {
#.ov.plot create rect [nnx $x0] [nny $y0] [expr [nnx $x0]+50] [expr [nny $y0]+10] -fill white -outline white
.ov.plot create text [expr [nnx $x0]+5] [expr [nny $y0]+5] \
            -fill red -anchor sw -text "([format "%4.2f" $x0],[format "%4.2f" $y0])"
}

if {$timeplot==1} {init_timeplot}

# set delt 0.01
set x $x0
set y $y0
set t $t0

set stop 0
set i 0
while {$stop==0 && $i<[expr $endtime/$delt]} {
incr i

set ta $t
set xa $x
set ya $y
set fx [expr $commandx]
set fy [expr $commandy]

# Euler
set x [expr $xa + $delt*$fx]
set y [expr $ya + $delt*$fy]
set t [expr $ta+$delt]

set color orange
if {$which =="rk"} {
# Runge-Kutta 2ter Ordnung
# y(k+1)=y(k) + 1/2 *h *( f(t(k),y(k)) + f( t(k+1), y(k) + h*f(t(k),y(k) ) ) )
# f(t(k),y(k))

# f( t(k+1), y(k) + h*f(t(k),y(k) )
set fxn [expr $commandx]
set fyn [expr $commandy]
set x [expr $xa+0.5*$delt*($fx + $fxn)]
set y [expr $ya+0.5*$delt*($fy + $fyn)]
set color red
}

.ov.plot create line [nnx $xa] [nny $ya] [nnx $x] [nny $y] -fill $color
if {$showpoints==1} {.ov.plot create oval [expr [nnx $x]-2] [expr [nny $y]-2] [expr [nnx $x]+2] [expr [nny $y]+2] -fill $color -outline $color}

if {$timeplot==1 && [winfo exist .second.plot]} {
  if {$commandx!=1} {
    .second.plot create line [bnnx $ta] [bnny $xa]  [bnnx $t] [bnny $x]  -fill black
  }
    .second.plot create line [bnnx $ta] [bnny $ya]  [bnnx $t] [bnny $y]  -fill red
}

set axmin [min $axmin $x]
set axmax [max $axmax $x]
set aymin [min $aymin $y]
set aymax [max $aymax $y]

if {[expr abs($x)] > 10000000} {set stop 1}
if {[expr abs($y)] > 10000000} {set stop 1}


update
update idletasks
}

if [winfo exist .ov.plot] {.ov.plot raise title}
}




